import java.io.IOException;
import java.io.File;
import java.text.SimpleDateFormat;
import java.util.Calendar;

public class ProcessFilesThreaded extends Thread {
    
    ComskipMonitor csm;
    File file;
    String[] cmd;
    int filenameArrayPosition;

    public ProcessFilesThreaded(String str, ComskipMonitor csm, File file, String[] cmd, int filenameArrayPosition){
        super(str);
        this.csm = csm;
        this.file = file;
        this.cmd = cmd;
        this.filenameArrayPosition = filenameArrayPosition;
    }
    
    public void run() {
        
        System.out.println("Starting file processing thread " + getName());

        cmd[filenameArrayPosition] = file.getAbsolutePath();
        Runtime runtime = Runtime.getRuntime();
        System.out.println("Execing " + cmd[0] + " " + " " + cmd[filenameArrayPosition] + " at " + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(Calendar.getInstance().getTime()) + " in thread " + getName());
        try
        {
        csm.logProcessing(file.getAbsolutePath() + " in thread " + getName() + " via " + cmd[0]);
        Process process = runtime.exec(cmd);
        StreamGobbler errorGobbler = new StreamGobbler(process.getErrorStream(), "ERROR");
        StreamGobbler outputGobbler = new StreamGobbler(process.getInputStream(), "OUTPUT");

        errorGobbler.start();
        outputGobbler.start();

        int exitCode = process.waitFor();
        System.out.println("Exit Code:" + exitCode);
        csm.cleanupLogs();
        }
      catch (IOException ioe)
      {
        System.out.println("Error executing comskip on file:" + file.getAbsolutePath());
      }
      catch (InterruptedException ie)
      {
        System.out.println("Interupted exception. Please report this bug.");
      }
      System.out.println("File processing thread " + getName() + " complete.");
    }
}
