import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

/**
 *
 * Helper thread to process comskip's output and error streams.
 *
 * Special thanks to Michael C. Daconta
 * Courtesy of http://www.javaworld.com/javaworld/jw-12-2000/jw-1229-traps.html
 *
 */
class StreamGobbler extends Thread
{
  InputStream is;
  String type;
  public boolean logOutput = true;

  StreamGobbler(InputStream is, String type)
  {
    this.is = is;
    this.type = type;
  }

  public void run()
  {
    try
    {
      InputStreamReader isr = new InputStreamReader(is);
      BufferedReader br = new BufferedReader(isr);
      String line = null;
      while ((line = br.readLine()) != null)
      {
        if(logOutput)
        {
          System.out.println(type + ">" + line);
        }
      }
    }
    catch (IOException ioe)
    {
      ioe.printStackTrace();
    }
  }

}
