@echo off
REM #######
REM ### Example batch file for use with comskip monitor
REM #######

REM ## This batch file executes ccextractor (http://ccextractor.sourceforge.net/) on video files.
REM ## CCextractor supports running on files as they are recording, so this batch file can be executed 
REM ## on files as they are recording too.  As written, this batch file generates an .srt file (from ccextractor)
REM ## and an .srtlog file (by output redirection of the ccextractor output).  This output redirection
REM ## technique can be leveraged to create an arbitrary file type for use by comskip monitor to keep track
REM ## of files with.  This should enable you to successfully use the batch functionality even if the process
REM ## you want to run against the video file does not generate any output file of its own (in the worst case,
REM ## you could just echo something to the redirected file before the main process starts).  Note that
REM ## batch files are called with the full path to the video file as the only argument (stored in the %1 variable).
REM ## Note also that if you parse the path within the batch file, as we are doing for the output redirection,
REM ## you need to quote it, as the path could have spaces in it.  %1 doesn't need to be quoted, as the path
REM ## argument will already be quoted when the batch is called.
REM ##
REM ## NOTE: For this batch file to function, you will need to download ccextractor, unzip it somewhere,
REM ## and edit the path to the executable below.  I unzipped mine into the comskip monitor install folder.
REM ## Edit the arguments you want to pass to ccextractor to your liking below.  Be sure to keep the "--stream"
REM ## argument if you want to run this batch during recordings.
REM ##
REM ## I have found that ccextractor is an I/O hog when running against previously-recorded files, so
REM ## I configured the batch file to launch it at "low" priority.  This is probably a good idea for any
REM ## process you want to run, to avoid problems with the recording application.  I should mention that,
REM ## with four threads of ccextractor running, even at low priority it made watching recorded shows impossible
REM ## due to limited disk bandwidth, so I wouldn't turn it loose on your entire library during prime time hours.
REM ## Even off-hours you might set your thread count down to 1 or 2 unless you want to torture-test your drives.
REM ## This only applies if you are trying to run ccextractor on a substantial existing recording library, of
REM ## course, as was the case for me.
REM ##
REM ## Assuming this batch file is placed in the comskip monitor install folder (alongside the csm.properties file)
REM ## the necessary settings in your csm.properties file to activate the batch execution process are as follows:
REM ## 
REM ## bat.location=../csm.bat
REM ## bat.cleanup.extensions=.srt,.srtlog
REM ## execute.during.record.bat=yes
REM ## 

start "ccextractor" /low /b /wait C:\ComskipMonitor\ccextractor.0.53.windows.binaries\ccextractorwin.exe --out=srt --stream 10 --no_progress_bar --norollup %1 > "%~dpn1.srtlog"